<?php

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgBill_gatewaysPayrobokassa extends JPlugin
{
	var $_db = null;
	function plgBill_gatewaysPayrobokassa(& $subject, $config)
	{
		$this->_db = JFactory :: getDBO();
		parent :: __construct($subject, $config);
	}
	function onReceivePayment(&$post)
	{

		if($post['processor'] != 'payrobokassa') return 0;

		$sql = "SELECT ud.params FROM #__jc_users AS ud " . 
					"INNER JOIN #__bills_invoice AS bi ON bi.seller_id = ud.user_id " .
					"INNER JOIN #__jc_orders AS o ON o.id = bi.order_num " .
					"WHERE bi.id = {$post['InvId']} && bi.client = 'Mighty Commerce' AND ud.section_id = o.section_id " . 
					"LIMIT 1";		
		$this->_db->setQuery($sql);
		$param_res = $this->_db->loadResult();
		
		if ( $param_res )
		{ //get vendor params
		  $default = new JParameter($param_res);
		}
		else
		{ // params will take from plugin manager
		  $default = $this->params;
		}
		
		$params = new JParameter($post['params']);

		$out['sid'] = $inv_id = $post["InvId"];
		$out['gateway'] = $post['processor'];
		$out['user_id']	= $user_id = $post["Shp_item"];
		$out['gateway_id'] = $gateway_id = $post["Shp_itemgtw"];
		$out['price'] = $out_summ = $post["OutSum"];

		if(isset($post['pay']))
		$out['pay'] = $post['pay'];

		$out['email'] = $post['Email'];
		$crc = $post["SignatureValue"];
		
		$mrh_login = $params->get('payrobokassa_login', $default->get('payrobokassa_login'));
		$mrh_pass2 = $params->get('payrobokassa_psw2', $default->get('payrobokassa_psw2'));
		$mrh_pass1 = $params->get('payrobokassa_psw1', $default->get('payrobokassa_psw1'));

		$crc = strtoupper($crc);

		if(isset($post['shpcheckresult']))
		{
			$my_crc = strtoupper(md5("$out_summ:$inv_id:$mrh_pass2:Shp_item=$user_id:Shp_itemgtw=$gateway_id"));
			if ($my_crc == $crc)
			{
				echo 'OK'.$out['sid'];
				exit;
			}
		}

		$my_crc = strtoupper(md5("$out_summ:$inv_id:$mrh_pass1:Shp_item=$user_id:Shp_itemgtw=$gateway_id"));
		
//error_log("\n my_crc plugin: ".print_r($my_crc, true), 3, JPATH_CACHE.DS.'log.txt');
//error_log("\n\n crc plugin: ".print_r($crc, true), 3, JPATH_CACHE.DS.'log.txt');
		
		// check signature
		if ($my_crc != $crc)
			$out['pay'] = 'fail';
		else
			$out['pay'] = 'success';

		if(class_exists('Bill')) 
			$out['key']  = strtoupper(md5(Bill::getSecretWord().$out['user_id'].$out['gateway_id'].$out['price'].$out['sid']));

		// save order info to file
		if($params->get('payrobokassa_errorlog', $default->get('payrobokassa_errorlog')))
			error_log("[Start get post]:  ".print_r($post, true)."\n\n", 3, JPATH_ROOT.DS.'plugins'.DS.'bill_gateways'.DS.'rk_log.txt');

		return $out;
	}

	function onSendPayment(&$post)
	{
		global $mainframe;
		if($mainframe->isAdmin()) return;

		if($post['processor'] != 'payrobokassa') return false;

		$user = &JFactory::getUser();

		$default = $this->params;
		$params = new JParameter( $post['params'] );

		$mrh_login = $params->get('payrobokassa_login', $default->get('payrobokassa_login'));
		$mrh_pass1 = $params->get('payrobokassa_psw1', $default->get('payrobokassa_psw1'));

		// number of order
		$inv_id = @$post['order_id'];

		// order description
		$inv_desc = $post['order_title'];

		// sum of order
		$out_summ = @floatval($post['order_amount']);

		// code of goods
		$gateway = time();

		// default payment e-currency
		$in_curr = $params->get('payrobokassa_curr', $default->get('payrobokassa_curr'));

		// language
		$culture = $params->get('payrobokassa_lang', $default->get('payrobokassa_lang'));

		// generate signature
		$crc  = md5("$mrh_login:$out_summ:$inv_id:$mrh_pass1:Shp_item=".$user->id.":Shp_itemgtw=$gateway");

		$param = array();
		$param['MrchLogin'] = $mrh_login;
		$param['OutSum'] = $out_summ;
		$param['InvId'] = $inv_id;
		$param['Desc'] = $inv_desc;
		$param['SignatureValue'] = $crc;
		$param['Shp_item'] = $user->id;
		$param['Shp_itemgtw'] = $gateway;
		$param['IncCurrLabel'] = $in_curr;
		$param['Culture'] = $culture;
		$param['Email'] = isset($post['email']) ? $post['email'] : $user->email;



		$url = "https://merchant.roboxchange.com/Index.aspx";
// 		$url = "http://test.robokassa.ru/Index.aspx";
		$txt = '';
		$txt .= '<dl id="system-message">
					<dt class="notice">Message</dt>
					<dd class="notice">
						<ul>
							<li>
							'.JText::_("This page will redirect you to the payment gateway in").' <span id="countDown">5 '.JText::_('seconds').'</span>
							</li>
						</ul>
					</dd>
	  			</dl>';
		$txt .= '<form action="'.$url.'" method="post" name="formPayBill">';
		foreach ($param as $name => $val)
		{
			$txt .= '<input type="hidden" name="'.$name.'" value="'.$val.'">';
		}
		$txt .= '<script type="text/javascript">
				countdown(5);
				function countdown(i)
				{				
					document.getElementById("countDown").innerHTML = i + (i == 1 ? " second": " seconds");
					i = i - 1;
					if(i >= 0)
					setTimeout("countdown(" + i + ")", 1000);
					else
					document.formPayBill.submit();
				}
				</script>
				<noscript>
				<p>'.JText::_('If you are not redirected automatically please click the button Send').'
				<input type="submit" value="'.JText::_('Send').'" class="button">
				</p>
				</noscript>';
		$txt .= '</form>';

		echo $txt;

	}

	function onCheckParams($params)
	{
		$db = JFactory::getDBO();
		$sql = "SELECT name FROM #__plugins WHERE folder = 'payment' AND element = 'payrobokassa'";
		$db->setQuery($sql);
		$title = $db->loadResult();
		if($params->get('payrobokassa_login') == '')
		JError::raiseNotice(100, $title.': '.JText::_('Merchant login is not set'));
		if($params->get('payrobokassa_psw1') == '')
		JError::raiseNotice(100, $title.': '.JText::_('Merchant password #1 is not set'));
		if($params->get('payrobokassa_psw2') == '')
		JError::raiseNotice(100, $title.': '.JText::_('Merchant password #2 is not set'));
	}
}

function RKArray2Url($param)
{
	foreach($param AS $k => $v)
	{
		$out[] = "$k=$v";
	}
	return implode('&', $out );
}
?>